#!/usr/bin/python3
# -*- coding: utf-8 -*

import numpy as np
import sys

try:
    in_file = open(sys.argv[1], 'rb')
except:
    sys.exit('usage: %s /path/to/power_consumption.npz' % sys.argv[0])

arr_0 = np.load(in_file)['arr_0']

begin=700000
end=1489000

step = 400

start = int((begin+end)/2)
rsa_one = arr_0[start:(start+step)]

trace = arr_0[begin:end]

diffs = []
for i in range(0, end-begin-step-1):
    diff = trace[i:(i+len(rsa_one))] - rsa_one
    diffs.append(np.sum(abs(diff)))

diffs = np.array(diffs)
loc = np.where(diffs < 7)

#Get actual list
loc = loc[0]

# bit 0 est 1
recovered_key = 1

bitnum = 1

for i in range(0, len(loc)-1):
    delta = loc[i+1]-loc[i]

    if delta > 800:
       recovered_key |= 1<<bitnum
    bitnum += 1

print("%0x"%recovered_key)
