#!/usr/bin/python3
# -*- coding: utf-8 -*

import sys

BUT = 0

def info(msg):
	print("[\033[34;1mi\033[0m] %s" % (msg))

def ok(msg):
	print("[\033[32;1m+\033[0m] %s" % (msg))

def warn(msg):
	print("[\033[33;1mw\033[0m] %s" % (msg))

def error(msg):
	print("[\033[31;1m!\033[0m] %s" % (msg))

def mynot(in1):
	return (~in1) & 1

def gate1(in1, in2, in3):
	return ((in1 & in2) | (mynot(in2) & in3))

def up(but3, a0, a1, a2, a3, a4, a5, a6, a7):
	out1 = gate1(a6, but3, a7)
	out2 = gate1(a5, but3, a6)
	out3 = gate1(a4, but3, a5)
	out4 = gate1(a3, but3, a4)
	out5 = gate1(a2, but3, a3)
	out6 = gate1(a1, but3, a2)
	out7 = gate1(a0, but3, a1)
	out8 = gate1(a7, but3, a0)
	return (out1, out2, out3, out4, out5, out6, out7, out8)

def middle(but4, b0, b1, b2, b3, b4, b5, b6, b7):
	out1 = gate1(b6, but4, b7)
	out2 = gate1(b5, but4, b6)
	out3 = gate1(b4, but4, b5)
	out4 = gate1(b3, but4, b4)
	out5 = gate1(b2, but4, b3)
	out6 = gate1(b1, but4, b2)
	out7 = gate1(b0, but4, b1)
	out8 = gate1(b7, but4, b0)
	return (out1, out2, out3, out4, out5, out6, out7, out8)

def gate2(in1, in2):
	# 3 outputs
	out1 = in1 ^ in2
	out2 = in1 & in2
	out3 = in1 | in2
	return (out1, out2, out3)

def gate3(in1, in2, in3):
	# 2 outputs
	out1 = (in1 & in2) | in3
	out2 = in1 ^ in2
	return (out1, out2)

def down1(in1, in2, in3, in4):
	# 2 outputs
	(g2out1, g2out2, g2out3) = gate2(in1, in2)
	otmp1 = gate1(g2out1, in3, g2out1)
	otmp2 = gate1(g2out3, in3, g2out2)
	out2 = gate1(otmp1, in4, otmp2)
	out1 = g2out2
	return (out1, out2)

def down2(in1, in2, in3, in4, in5):
	# 2 outputs
	(g2out1, g2out2, g2out3) = gate2(in2, in3)
	(out1, g3out2) = gate3(in1, g2out1, g2out2)
	otmp1 = gate1(g3out2, in4, g2out1)
	otmp2 = gate1(g2out3, in4, g2out2)
	out2 = gate1(otmp1, in5, otmp2)
	return (out1, out2)

def opgate(but1, but2, op0, op1):
	# 2 outputs
	out1 = (mynot(but1) & op0) | (but1 & mynot(op0))
	out2 = (op1 & mynot(but2)) | (mynot(op1) & but2)
	return (out1, out2)



def secure_device(a,b,op):
	out = 0
	"""
	TODO : 
		- Implémentation de la communication avec le secure element
			* Entrées A et B (A0 = bit de poids faible)
			* Entrée OP
			* Sortie Out (Out0 = bit de poids faible)
			* Les boutons permettent à l'utilisateur de rentrer sa combinaison secrète pour le déchiffrement
		- Supprimer les docs de conception 
	"""
	a0 = (a >> 0) & 1
	a1 = (a >> 1) & 1
	a2 = (a >> 2) & 1
	a3 = (a >> 3) & 1
	a4 = (a >> 4) & 1
	a5 = (a >> 5) & 1
	a6 = (a >> 6) & 1
	a7 = (a >> 7) & 1

	b0 = (b >> 0) & 1
	b1 = (b >> 1) & 1
	b2 = (b >> 2) & 1
	b3 = (b >> 3) & 1
	b4 = (b >> 4) & 1
	b5 = (b >> 5) & 1
	b6 = (b >> 6) & 1
	b7 = (b >> 7) & 1

	op0 = (op >> 0) & 1
	op1 = (op >> 1) & 1

	global BUT
	but1 = (BUT >> 0) & 1
	but2 = (BUT >> 1) & 1
	but3 = (BUT >> 2) & 1
	but4 = (BUT >> 3) & 1


	(upout1, upout2, upout3, upout4, upout5, upout6, upout7, upout8) = up(but3, a0, a1, a2, a3, a4, a5, a6, a7)
	(midout1, midout2, midout3, midout4, midout5, midout6, midout7, midout8) = middle(but4, b0, b1, b2, b3, b4, b5, b6, b7)
	(leftout1, leftout2) = opgate(but1, but2, op0, op1)
	(otmp, out0) = down1(upout8, midout8, leftout1, leftout2)
	(otmp, out1) = down2(otmp, upout7, midout7, leftout1, leftout2)
	(otmp, out2) = down2(otmp, upout6, midout6, leftout1, leftout2)
	(otmp, out3) = down2(otmp, upout5, midout5, leftout1, leftout2)
	(otmp, out4) = down2(otmp, upout4, midout4, leftout1, leftout2)
	(otmp, out5) = down2(otmp, upout3, midout3, leftout1, leftout2)
	(otmp, out6) = down2(otmp, upout2, midout2, leftout1, leftout2)
	(otmp, out7) = down2(otmp, upout1, midout1, leftout1, leftout2)

	out = 0
	out |= (out0 << 0)
	out |= (out1 << 1)
	out |= (out2 << 2)
	out |= (out3 << 3)
	out |= (out4 << 4)
	out |= (out5 << 5)
	out |= (out6 << 6)
	out |= (out7 << 7)

	return out

def step1():
	r = secure_device(0x35,0x27,3)
	r = secure_device(0x7e,r,3)
	r = secure_device(0x66,r,2)
	r = secure_device(0x8,r,1)
	r = secure_device(0x13,r,0)
	r = secure_device(0x1f,r,1)
	r = secure_device(0xa,r,2)
	r = secure_device(0xd3,r,0)
	r = secure_device(0xc6,r,3)

	return r

def step2():
	r= secure_device(0xde,0xab,0)
	r= secure_device(0x67,r,3)
	r= secure_device(0x2a,r,2)
	r= secure_device(0x6d,r,1)
	r= secure_device(0x4a,r,3)
	r= secure_device(0xe7,r,0)
	r= secure_device(0x1c,r,1)
	r= secure_device(0x35,r,0)
	r= secure_device(0xde,r,3)
	r= secure_device(0xf7,r,0)
	r= secure_device(0xda,r,2)
	return r

def step3():
	r = secure_device(0x14,0x23,3)
	r = secure_device(0x72,r,0)
	r = secure_device(0x48,r,3)
	r = secure_device(0x53,r,1)
	r = secure_device(0xa7,r,0)
	r = secure_device(0x5f,r,1)
	r = secure_device(0x3,r,3)
	r = secure_device(0xb7,r,3)
	r = secure_device(0x73,r,1)
	r = secure_device(0x37,r,3)
	r = secure_device(0xc5,r,2)
	r = secure_device(0xa4,r,1)
	r = secure_device(0x30,r,0)
	r = secure_device(0xdd,r,2)
	return r


def step4():
	r = secure_device(0xb0,0x42,2)
	r = secure_device(0xbc,r,2)
	r = secure_device(0xfc,r,2)
	r = secure_device(0x54,r,3)
	r = secure_device(0x30,r,2)
	r = secure_device(0x97,r,1)
	r = secure_device(0xe8,r,2)
	r = secure_device(0xd6,r,0)
	r = secure_device(0x26,r,0)
	r = secure_device(0xeb,r,0)
	r = secure_device(0x68,r,1)
	r = secure_device(0x26,r,0)
	r = secure_device(0x9,r,3)
	r = secure_device(0x2a,r,2)
	r = secure_device(0xa9,r,3)
	return r


def step5():
	r = secure_device(0xff,0x12,0)
	r = secure_device(0xfd,r,1)
	r = secure_device(0xe5,r,1)
	r = secure_device(0x26,r,3)
	r = secure_device(0x85,r,3)
	r = secure_device(0x63,r,1)
	r = secure_device(0x93,r,3)
	r = secure_device(0xba,r,2)
	r = secure_device(0x97,r,0)
	r = secure_device(0xab,r,1)
	r = secure_device(0x6e,r,3)
	r = secure_device(0xfd,r,0)
	r = secure_device(0x4c,r,3)
	r = secure_device(0x50,r,0)
	r = secure_device(0xa,r,2)
	r = secure_device(0xfc,r,3)
	r = secure_device(0xe3,r,2)
	r = secure_device(0xa6,r,3)
	r = secure_device(0x64,r,2)
	r = secure_device(0x8e,r,3)
	r = secure_device(0xc1,r,1)
	return r

def step6():
	r = secure_device(0x90,0x77,1)
	r = secure_device(0x8e,r,0)
	r = secure_device(0xbd,r,2)
	r = secure_device(0x39,r,2)
	r = secure_device(0x4c,r,2)
	r = secure_device(0xc5,r,2)
	r = secure_device(0xb6,r,3)
	r = secure_device(0x93,r,1)
	r = secure_device(0x9f,r,3)
	r = secure_device(0xd6,r,3)
	r = secure_device(0x6e,r,2)
	r = secure_device(0x39,r,3)
	r = secure_device(0x40,r,1)
	r = secure_device(0x14,r,2)
	r = secure_device(0xe6,r,3)
	return r

def step7():
	r = secure_device(0xf,0xab,3)
	r = secure_device(0xa2,r,1)
	r = secure_device(0x7c,r,0)
	r = secure_device(0x34,r,1)
	r = secure_device(0x14,r,1)
	r = secure_device(0xe7,r,0)
	r = secure_device(0xb9,r,0)
	r = secure_device(0xf1,r,2)
	r = secure_device(0xd5,r,1)
	r = secure_device(0x4e,r,2)
	r = secure_device(0xe,r,2)
	r = secure_device(0x6,r,0)
	r = secure_device(0x7d,r,2)
	r = secure_device(0x87,r,3)
	r = secure_device(0xbc,r,0)
	r = secure_device(0xd4,r,3)
	r = secure_device(0x8a,r,1)
	r = secure_device(0xe7,r,3)
	r = secure_device(0x9e,r,1)
	r = secure_device(0x58,r,0)
	r = secure_device(0x24,r,2)
	r = secure_device(0x44,r,3)
	r = secure_device(0xc9,r,1)
	r = secure_device(0xd4,r,1)
	r = secure_device(0x1d,r,3)
	r = secure_device(0xcd,r,0)
	r = secure_device(0xde,r,1)
	r = secure_device(0x54,r,0)
	r = secure_device(0x5e,r,2)
	r = secure_device(0x46,r,1)
	r = secure_device(0x21,r,0)
	r = secure_device(0xff,r,1)
	r = secure_device(0x51,r,0)
	r = secure_device(0x78,r,1)
	r = secure_device(0x2f,r,3)
	r = secure_device(0xed,r,2)
	r = secure_device(0x4b,r,3)
	r = secure_device(0x4d,r,2)
	return r

def step8():
	r = secure_device(0x88,0x74,0)
	r = secure_device(0x48,r,2)
	r = secure_device(0x11,r,2)
	r = secure_device(0x76,r,0)
	r = secure_device(0x2b,r,3)
	r = secure_device(0xf8,r,2)
	return r



def init():
	r = secure_device(0x46,0x92,0)
	r = secure_device(0xdf,r,2)
	r = secure_device(0x3e,r,0)
	r = secure_device(0x3a,r,3)
	r = secure_device(0x36,r,2)
	r = secure_device(0x8e,r,2)
	r = secure_device(0xc9,r,3)
	r = secure_device(0xe7,r,1)
	r = secure_device(0x29,r,2)
	r = secure_device(0xc2,r,2)
	r = secure_device(0x79,r,0)
	r = secure_device(0x2a,r,2)
	r = secure_device(0x4c,r,3)
	r = secure_device(0xde,r,0)
	r = secure_device(0x88,r,0)
	r = secure_device(0x8b,r,2)
	r = secure_device(0x97,r,3)
	r = secure_device(0x6a,r,2)
	r = secure_device(0x60,r,1)
	r = secure_device(0x0f,r,0)
	r = secure_device(0x5b,r,3)
	r = secure_device(0xd0,r,2)
	r = secure_device(0xa9,r,1)
	r = secure_device(0xe3,r,3)
	r = secure_device(0xd0,r,1)
	r = secure_device(0x27,r,0)
	r = secure_device(0x90,r,0)
	r = secure_device(0x3b,r,1)
	r = secure_device(0x66,r,2)
	r = secure_device(0xe2,r,0)
	r = secure_device(0x24,r,3)
	r = secure_device(0xee,r,1)
	r = secure_device(0xf2,r,3)
	return r


def main():
	info("Dechiffrement du conteneur\n")

	info("Initialisation du secure element")

	info("Merci d'appuyer les 4 boutons du secure element puis appuyer sur entrée")
	global BUT
	BUT = 0xf
	if init()!=0xa1:
		error("Mauvaise initialisation, vérifiez l'état du sécure élement")
		sys.exit(0)
	else:
		ok("Initialisation, check 1 OK")

	info("Merci de relâcher les 4 boutons du secure element puis appuyer sur entrée")
	BUT = 0
	if init()!=0xe0:
		error("Mauvaise initialisation, vérifiez l'état du sécure élement")
		sys.exit(0)
	else:
		ok("Initialisation, check 2 OK")

	warn("Calcul de la clef de déchiffrement du conteneur, préparez vous à appuyer sur les boutons")

	info("Valeurs d'entrée du bruteforce :")
	ls1 = []
	ls2 = []
	ls3 = []
	ls4 = []
	ls5 = []
	ls6 = []
	ls7 = []
	ls8 = []
	for b in range(16):
		BUT = b
		ls1.append(step1())
		ls2.append(step2())
		ls3.append(step3())
		ls4.append(step4())
		ls5.append(step5())
		ls6.append(step6())
		ls7.append(step7())
		ls8.append(step8())

	print(ls1)
	print(ls2)
	print(ls3)
	print(ls4)
	print(ls5)
	print(ls6)
	print(ls7)
	print(ls8)

if __name__ == '__main__':
	main()
